/*
 * Exactly.java
 *
 * Created on February 18, 2002, 2:54 PM
 */

package org.semanticweb.dl;

import java.util.*;
import java.io.*;


/**
 * Exactly (qualified and unqualified)
 * @author  Michael Sintek
 * @version 
 */
public class Exactly extends Expression {

  Expression _expr1, _expr2;
  int _card;
  
  /** Creates new Exactly */
  public Exactly (int card, Expression expr1) {
    _card = card;
    _expr1 = expr1;
    _expr2 = Symbol.TOP;
  }
  
  public Exactly (int card, Expression expr1, Expression expr2) {
    _card = card;
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML()) { // this is not supported by FaCT!
      out.print ("<EXACTLY NUM=\"" + _card + "\">");
      _expr1.print (syntax, out);
      _expr2.print (syntax, out);
      out.print ("</EXACTLY>");
    } else {
      out.print ("(exactly " + _card + " ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.print (")");
    }
  }
  
  public Expression toSHIQ(KB kb, int mode) {
    // -> at_least and at_most
    ArrayList list = new ArrayList(2);
    Expression e1 = _expr1.toSHIQ(kb, ROLE);
    Expression e2 = _expr2.toSHIQ(kb, CONCEPT);
    list.add(new AtLeast(_card, e1, e2));
    list.add(new AtMost(_card, e1, e2));
    return And.getAnd(list);
  }

}
