/*
 * ExpressionList.java
 *
 * Created on February 19, 2002, 4:09 PM
 */

package org.semanticweb.dl;

import java.util.*;
import java.io.*;


/**
 * ExpressionList is what DAML lists are mapped to.
 * These lists are only used internally.
 * @author  Michael Sintek
 * @version 
 */
public class ExpressionList extends Expression {

  ArrayList _expressions;
  
  /** Creates new ExpressionList */
  public ExpressionList(ArrayList expressions) {
    _expressions = expressions;
  }
  
  public boolean isEmpty() {
    return _expressions.isEmpty();
  }
  
  public ArrayList getList() {
    return _expressions;
  }

  public void print(Syntax syntax, PrintWriter out) {
    // for debugging only, so we don't care about the syntax
    out.print("[");
    printSequence(_expressions, syntax, out);
    out.print("]");
  }

  // no toSHIQ: should never occur in result expressions
  
}
