/*
 * Range.java
 *
 * Created on February 18, 2002, 5:10 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * Range assertion (for roles).
 * @author  Michael Sintek
 * @version 
 */
public class Range extends Assertion {

  Expression _expr1, _expr2;
  
  /** Creates new Range */
  public Range(Expression expr1, Expression expr2) {
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<RANGE>");
      out.print("<ROLE>");
      _expr1.print (syntax, out);
      out.print("</ROLE>");
      out.print("<CONCEPT>");
      _expr2.print (syntax, out);
      out.print("</CONCEPT>");
      out.println ("</RANGE>");
    } else {
      out.print ("(range ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.println (")");
    }
  }
  
  public void toSHIQ(KB kb) {
    // (range r c) -> (implies TOP (all r c))
    kb.add(new Implies(Symbol.TOP,
      new All(_expr1.toSHIQ(kb, ROLE), _expr2.toSHIQ(kb, CONCEPT))));
  }

}
