/*
 * Unique.java
 *
 * Created on February 18, 2002, 5:10 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * Unique (functional) assertion (for roles).
 * @author  Michael Sintek
 * @version 
 */
public class Unique extends Assertion {

  Expression _expr;
  
  /** Creates new Unique */
  public Unique(Expression expr) {
    _expr = expr;
  }
  
  public void print (Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<FUNCTIONAL>");
      out.print ("<ROLE>");
      _expr.print (syntax, out);
      out.print ("</ROLE>");
      out.println ("</FUNCTIONAL>");
    } else {
      out.print ("(functional ");
      _expr.print (syntax, out);
      out.println (")");
    }
  }
  
  public void toSHIQ(KB kb) {
    // is directly supported in SHIQ (functional)
    kb.add(new Unique(_expr.toSHIQ(kb, ROLE)));
  }


}
