package org.semanticweb.triple.inference;

/**
 *  Copyright  Juergen Angele and Stefan Decker, Institut AIFB, University of
 *  Karlsruhe. All Rights Reserved.
 *
 *@author     Administrator
 *@created    January 17, 2002
 */

/*
 *  Name: BuiltinFunc.java
 *  Version: 1.01
 *  Purpose:
 *  History:
 *  2.5.99 Added support for new builtin mechanism. SDe
 *  (Some Methods are declared public now)
 *  3.5.99 Deleted arity and symbol method again. SDe
 *  20.9.99 method retract added. JAn
 */
public class BuiltinFunc {
    /**
     *  Description of the Field
     */
    public SimpleEvaluator eval = null;
    /**
     *  Description of the Field
     */
    public Atoms D;
    /**
     *  Description of the Field
     */
    public Atoms B;
    int index[];
    Atom T;
    Atom ins;


    /**
     *  Constructor for the BuiltinFunc object
     */
    public BuiltinFunc() {
        eval = null;
    }


    /**
     *  Constructor for the BuiltinFunc object
     *
     *@param  eval  Description of the Parameter
     */
    public BuiltinFunc(SimpleEvaluator eval) {
        this.eval = eval;
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) { }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        return true;
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     */
    public void insert(Atom t1) {
        Atom t;
        boolean inserted;
        boolean unified;
        Variable v;

        unified = T.Match(t1);
        t = new Atom(D.arity);
        for (v = T.variables; v != null; v = v.next) {
            t.terms[index[v.symbol]] = v.subsby;
        }
        ins = (Atom) D.Insert(t);
        if (ins == t) {
            t.next2 = D.tuples2;
            D.tuples2 = t;
        }
        else {
            t = null;
        }
        t1.Supports(ins);
        t1.ClearVariables();
        T.ClearVariables();
    }


    /**
     *  Description of the Method
     *
     *@param  T  Description of the Parameter
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    boolean isevaluable(Atom T, Atom t) {
        Variable v;
        Atom f;
        int i;
        for (v = T.variables; v != null; v = v.next) {
            v.subsby = t.terms[v.symbol];
        }
        f = new Atom(T.terms.length);
        for (i = 0; i < T.terms.length; i++) {
            f.terms[i] = T.terms[i].Substitute();
        }
        f.Variables();
        T.ClearVariables();
        return evaluable(f);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     */
    public void retract(Atom t1) {
        t1.Retract();
    }
}
