package org.semanticweb.triple.inference;

/*
 *  Name: ConstTerm.java
 *  Version: 1.2
 *  Purpose: realizes terms containing constants
 *  History: function internalize1 returning a string added (jan)
 *  interface simplified
 */
import java.io.*;
import java.util.*;
import java.net.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class ConstTerm extends Term {
    // type == 4
    /**
     *  Description of the Field
     */
    public int symbol;


    // reprsentiert die Konstante

    /**
     *  Constructor for the ConstTerm object
     *
     *@param  sym  Description of the Parameter
     */
    public ConstTerm(int sym) {
        // Konstante
        super(0, true);
        symbol = sym;
        ground = true;
    }


    /**
     *  Constructor for the ConstTerm object
     *
     *@param  sym    Description of the Parameter
     *@param  terms  Description of the Parameter
     */
    public ConstTerm(int sym, Term terms[]) {
        // Funktion mit Symbol sym als Funktionssymbol
        // terms enthaelt die Parameter
        super(terms);
        symbol = sym;
    }


    /**
     *  Constructor for the ConstTerm object
     *
     *@param  sym          Description of the Parameter
     *@param  stelligkeit  Description of the Parameter
     *@param  grnd         Description of the Parameter
     */
    public ConstTerm(int sym, int stelligkeit, boolean grnd) {
        super(stelligkeit, grnd);
        symbol = sym;
        ground = grnd;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Term CloneFlat() {
        return new ConstTerm(symbol, pars.length, ground);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int CompareFlat(Term t) {
        // Vergleicht zwei einzelne ConstTerme aufgrund ihres Symbols
        return symbol <= ((ConstTerm) t).symbol ? (symbol < ((ConstTerm) t).symbol ? -1 : 0) : 1;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String InternalizeFlat() {
        return "c" + String.valueOf(symbol);
    }


    /**
     *  Gets the constTerm attribute of the ConstTerm object
     *
     *@return    The constTerm value
     */
    public boolean isConstTerm() {
        if (symbol >= 0) {
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Gets the stringTerm attribute of the ConstTerm object
     *
     *@return    The stringTerm value
     */
    public boolean isStringTerm() {
        if (symbol >= SimpleEvaluatorConfig.STRINGSTART) {
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toStringFlat() {
        // Ausgabe des ConstTerms als Zeichenkette
        return "c" + String.valueOf(symbol);
    }


    /**
     *  Description of the Method
     *
     *@param  p  Description of the Parameter
     *@param  f  Description of the Parameter
     *@param  s  Description of the Parameter
     *@return    Description of the Return Value
     */
    public String toStringFlat(String p[], String f[], String s[]) {
        if (symbol >= SimpleEvaluatorConfig.STRINGSTART) {
            return s[symbol - SimpleEvaluatorConfig.STRINGSTART];
        }
        else {
            return f[symbol];
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int Type() {
        return 4;
    }
}
