package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Filtering extends Operation {
    /**
     *  Constructor for the Filtering object
     *
     *@param  R1    Description of the Parameter
     *@param  ix1   Description of the Parameter
     *@param  R2    Description of the Parameter
     *@param  ix2   Description of the Parameter
     *@param  D     Description of the Parameter
     *@param  T     Description of the Parameter
     *@param  Time  Description of the Parameter
     */
    public Filtering(Atoms R1, int ix1[], Atoms R2, int ix2[], Atoms D, Atom T, long Time) {
        super(R1, ix1, R2, ix2, Time);
        this.D = D;
        D.tuples2 = null;
        this.T = T;
//System.out.println(T.toString());
        comp1 = new CompareAtoms(ix1, ix2);
        comp2 = new CompareAtoms(ix2, ix1);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t1, GroundAtom t2) {
        int i;
        GroundAtom f;
        GroundAtom ins;
        Variable v;
        boolean res = true;
        Atom t = (Atom) t1;
        res = t.Match(t2);
        t.ClearVariables();
        if (res) {
            res = T.Match(t2);
            if (res) {
                f = new GroundAtom(D.arity);
                for (v = T.variables, i = 0; v != null; v = v.next, i++) {
                    f.terms[i] = v.subsby;
                }
                ins = D.Insert(f);
                t2.Supports(ins);
                ins.cycle = T.cycle;
                if (ins == f) {
                    f.next2 = D.tuples2;
                    D.tuples2 = f;
                }
            }
        }
        T.ClearVariables();
        if (t.lasttouched < timestamp) {
            t.next2 = R1.tuples2;
            R1.tuples2 = t;
            t.lasttouched = timestamp;
        }
        if (t2.lasttouched < timestamp) {
            t2.next2 = R2.tuples2;
            R2.tuples2 = t2;
            t2.lasttouched = timestamp;
        }
    }
}
