package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Join extends Operation {
    /**
     *  Constructor for the Join object
     *
     *@param  R1   Description of the Parameter
     *@param  ix1  Description of the Parameter
     *@param  R2   Description of the Parameter
     *@param  ix2  Description of the Parameter
     *@param  D    Description of the Parameter
     *@param  dx1  Description of the Parameter
     *@param  dx2  Description of the Parameter
     *@param  T    Description of the Parameter
     */
    public Join(Atoms R1, int ix1[], Atoms R2, int ix2[], Atoms D, int dx1[], int dx2[], long T) {
        super(R1, ix1, R2, ix2, T);
        dindex1 = dx1;
        dindex2 = dx2;
        this.D = D;
        comp1 = new CompareGroundAtoms(ix1, ix2);
        comp2 = new CompareGroundAtoms(ix2, ix1);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t1, GroundAtom t2) {
        int i;
        GroundAtom t;
        GroundAtom ins;
        t = new GroundAtom(D.arity);
        for (i = 0; i < R1.arity; i++) {
            if (dindex1[i] != -1) {
                t.terms[dindex1[i]] = t1.terms[i];
            }
        }
        // t.Copy(dindex1[i],t1,i);
        for (i = 0; i < R2.arity; i++) {
            if (dindex2[i] != -1) {
                t.terms[dindex2[i]] = t2.terms[i];
            }
        }
        //t.Copy(dindex2[i],t2,i);
        ins = D.Insert(t);
        if (ins != t) {
            t = null;
        }
        (t1).Supports(ins);
        (t2).Supports(ins);
        if (t1.lasttouched != timestamp) {
            t1.next2 = R1.tuples2;
            R1.tuples2 = t1;
            t1.lasttouched = timestamp;
        }
        if (t2.lasttouched != timestamp) {
            t2.next2 = R2.tuples2;
            R2.tuples2 = t2;
            t2.lasttouched = timestamp;
        }
    }
}
