package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Match extends SearchOperation {
    /**
     *  Constructor for the Match object
     *
     *@param  R     Description of the Parameter
     *@param  T     Description of the Parameter
     *@param  D     Description of the Parameter
     *@param  Time  Description of the Parameter
     */
    public Match(Atoms R, Atom T, Atoms D, long Time) {
        super(R, T, D, Time);
    }


    /**
     *  Description of the Method
     *
     *@param  t   Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t, GroundAtom t2) {
        int i;
        GroundAtom f;
        GroundAtom ins;
        Variable v;
        boolean res = true;
        Atom T = (Atom) t2;
        res = (T).Match(t);
        if (res) {
            //flag = true;
            f = new GroundAtom(D.arity);
            for (v = (T).variables, i = 0; v != null; v = v.next, i++) {
                if (v.subsby != null) {
                    f.terms[i] = v.subsby;
                }
                else {
                    f.terms[i] = new Variable(v.symbol);
                }
            }
            ins = D.Insert(f);
            (t).Supports(ins);
            if (ins == f) {
                f.next2 = D.tuples2;
                D.tuples2 = f;
            }
        }
        (T).ClearVariables();
        // (t).ClearVariables();
        if (t.lasttouched < timestamp) {
            t.next2 = R1.tuples2;
            R1.tuples2 = t;
            t.lasttouched = timestamp;
        }
    }
}
