package org.semanticweb.triple.inference.builtins;
import java.lang.Math;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.Variable;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.NumTerm;

/**
 *  Copyright  Juergen Angele and Stefan Decker, Institut AIFB, University of
 *  Karlsruhe. All Rights Reserved.
 *
 *@author     Administrator
 *@created    January 17, 2002
 */

public class Add extends BuiltinFunc {

    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        int i;
        boolean ok = true;
        if (evaluable(t)) {
            ok = false;
            if (t.terms[0].ground && t.terms[1].ground && t.terms[2].ground) {
                if (((NumTerm) t.terms[0]).zahl + ((NumTerm) t.terms[1]).zahl == ((NumTerm) t.terms[2]).zahl) {
                    ok = true;
                }
            }
            else if (t.terms[0].ground && t.terms[1].ground) {
                ((Variable) t.terms[2]).subsby = new NumTerm(((NumTerm) t.terms[0]).zahl + ((NumTerm) t.terms[1]).zahl, 0, true);
                ok = true;
            }
            else if (t.terms[0].ground && t.terms[2].ground) {
                ((Variable) t.terms[1]).subsby = new NumTerm(((NumTerm) t.terms[2]).zahl - ((NumTerm) t.terms[0]).zahl, 0, true);
                ok = true;
            }
            else if (t.terms[1].ground && t.terms[2].ground) {
                ((Variable) t.terms[0]).subsby = new NumTerm(((NumTerm) t.terms[2]).zahl - ((NumTerm) t.terms[1]).zahl, 0, true);
                ok = true;
            }
            if (ok) {
                insert(t);
            }
        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        int i;
        int anzbound = 0;
        boolean ok = true;
        for (i = 0; i < 3; i++) {
            if (t.terms[i].ground) {
                anzbound++;
                if (!(t.terms[i] instanceof NumTerm)) {
                    ok = false;
                }
            }
            else if (!(t.terms[i] instanceof Variable)) {
                ok = false;
            }
        }
        if (anzbound < 2) {
            ok = false;
        }
        return ok;
    }
}
