/*
 * MoleculeTerm.java
 *
 * Created on February 5, 2002, 4:45 PM
 */

package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


/**
 * A MoleculeTerm is a molecule at term position.
 * @author  sintek
 * @version 
 */
public class MoleculeTerm extends Term {

  Term subject;
  ArrayList predicates = new ArrayList(); // of Term
  ArrayList objects = new ArrayList(); // of Term
  // INCOMPLETE: @module should also be allowed ... !!!

  public void putSubject(Term subject) { this.subject = subject; }
  
  public void putPredicateAndObject(Term predicate, Term object) {
    predicates.add(predicate);
    objects.add(object);
  }
  
  public String toString (Syntax syntax) {
    // ... share with Molecule ... !!!
    StringBuffer buffer = new StringBuffer();
    buffer.append(subject.toString(syntax));
    buffer.append("[");
    Iterator predIter = predicates.iterator();
    Iterator objIter = objects.iterator();
    while (predIter.hasNext()) {
      Term predicate = (Term)predIter.next();
      Term object = (Term)objIter.next();
      buffer.append(predicate.toString(syntax));
      buffer.append("->");
      buffer.append(object.toString(syntax));
      if (predIter.hasNext())
        buffer.append("; ");
    }
    buffer.append("]");
    // appendModel(syntax, buffer); ??? do we have a model ???
    return buffer.toString();
  }
  
  public GLPTerm toGLP(GLPTerm model, ArrayList glpFormulae) {
    // -> s' + add. conjuncts
    GLPTerm glpSubject = subject.toGLP(model, glpFormulae);
    Iterator predIter = predicates.iterator();
    Iterator objIter = objects.iterator();
    while (predIter.hasNext()) {
      Term pred = (Term)predIter.next();
      Term obj = (Term)objIter.next();
      GLPTerm glpPred = pred.toGLP(model, glpFormulae);
      GLPTerm glpObj = obj.toGLP(model, glpFormulae);
      ArrayList spo = new ArrayList(3);
      spo.add(glpSubject);
      spo.add(glpPred);
      spo.add(glpObj);
      GLPTermFunction glpTriple = new GLPTermFunction("triple", spo);
      ArrayList trueargs = new ArrayList(2);
      trueargs.add(glpTriple);
      trueargs.add(model);
      GLPAtom trueAtom = new GLPAtom("true", trueargs);
      glpFormulae.add(trueAtom);
    }
    return glpSubject;
  }
  
    
}
