package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


public class Or extends BinaryFormula {

  public String toString(Syntax syntax) {
    StringBuffer buffer = new StringBuffer();
    buffer.append("("); // we always want to have ()
    buffer.append(firstFormula.toString(syntax));
    buffer.append(syntax.getOr());
    buffer.append(secondFormula.toString(syntax));
    buffer.append(")");
    appendModel(syntax, buffer);
    return buffer.toString();
  }
  
  public GLogicFormula toGLP(GLPTerm model) {
    ArrayList glpFormulae = new ArrayList();
    model = overrideModel(model, this.model, glpFormulae);
    GLPOr glpOr = 
      new GLPOr(firstFormula.toGLP(model), secondFormula.toGLP(model));
    return And.makeGLPConjunction(glpFormulae, glpOr);
  }
  
}
